import { useEffect, useLayoutEffect, useState } from "react";
import { MathText } from "./MathText";

export const DialogText = (props: {children: string, onFinish?: () => void}) => {
	const {children: str, onFinish} = props;
	const [len, setLen] = useState(0);

	useLayoutEffect(() => {
		setLen(0);
	}, [str]);

	useEffect(() => {
		const interval = setInterval(() => {
			setLen(l => Math.max(l+1, str.length));
		}, 70);
		if (len === str.length) {
			// clearInterval(interval);
			onFinish && onFinish();
		}
		return () => {
			clearInterval(interval);
		};
	}, [str, setLen]);

	return <MathText>{str.slice(0, len)}</MathText>
}